from browser import document, window
from uuid import uuid4

def reset_x_scroll_width():
    for element in document.select('.scroll-item'):
        element.width = int(element.width - element.width*.15)
reset_x_scroll_width()

def scroll_horizontally(event):
    print(event.currentTarget.scrollWidth)
    print(window[f'lastXScrollValue-{event.currentTarget["id"]}'])
    """when vertical scrollbar goes down, horizontal scrollbar goes right"""
    # check if scrolling up or down (scroll bar is going down or not)
    scrolling_down = True if event.deltaY > 0 else False

    # check and continue default scroll up behaviour
    if not scrolling_down and event.currentTarget.scrollLeft == 0:
        # reset lastXScrollValue for the event
        window[f'lastXScrollValue-{event.currentTarget["id"]}'] = 0
        return True
    # check and continue default scroll down behaviour
    if scrolling_down and window[f'lastXScrollValue-{event.currentTarget["id"]}'] > event.currentTarget.scrollWidth:
        return True

    # update last_scrollLeft attribute in the event target
    window[f'lastXScrollValue-{event.currentTarget["id"]}'] = int(
        window[f'lastXScrollValue-{event.currentTarget["id"]}']) + int(
        event.deltaY)
    # do not allow negative value in lastXScrollValue
    if window[f'lastXScrollValue-{event.currentTarget["id"]}'] < 0:
        window[f'lastXScrollValue-{event.currentTarget["id"]}'] = 0

    # prevent default and scroll horizontally
    event.preventDefault()
    event.currentTarget.scrollLeft += event.deltaY


def bind_horizontal_scroll_over_x_scroll():
    x_scroll_divs = document.select('.x-scroll')
    for div in x_scroll_divs:
        # ensure min 4 items in div to allow horizontal scroll
        if len(div.select('.scroll-item')) < 4:
            return True
        div.bind('wheel', scroll_horizontally)
        runtime_uuid = uuid4().__str__()
        div['id'] = runtime_uuid
        window[f'lastXScrollValue-{runtime_uuid}'] = 0

bind_horizontal_scroll_over_x_scroll()